#include <windows.h>
#include <stdio.h>
#include "stddefs.h"
#include "rootscript.h"


#define DLL_VERSION 0x0110


static UWORD Cur_IdxW = 0;

DLLEXPORT UWORD STDCALL RS_Get_DLL_Version(void)
{
	return(DLL_VERSION);
}


DLLEXPORT FILE * STDCALL RS_Fopen ( char * filepath )
{
//	FILE * RFile;
	return fopen ( filepath, "wb" );
}


DLLEXPORT int STDCALL RS_Fclose ( FILE * file )
{
	return fclose ( file );
}
// decide if this is file or serial:
static int RS_Write ( const void * Buff, int size, int count, FILE * stream )
{
	// first test to see that one and only one stream ( file or comm ) is open:
	if ( ! stream  )
		return RS_ERROR_NOWHERE_TO_WRITE;
	// now get down to business; is this going to a file or a comm port?
	return fwrite ( Buff, size, count, stream );
	
	//return RS_SendRecord ( ( UBYTE * )Buff, size * count );
}


UWORD RS_SOP (FILE *fileptr)
{
	UBYTE sop[2] = {ESC, SOP};
	return(/*fwrite*/ RS_Write(sop,1,sizeof(sop),fileptr));	/* write SOP */
}


UWORD RS_EOP (FILE *fileptr)
{
	UBYTE eop[2] = {ESC, EOP};
	return(/*fwrite*/RS_Write(eop,1,sizeof(eop),fileptr));	/* write EOP */
}


UWORD RS_Data (UBYTE *data, UWORD size, FILE* fileptr)
{
	UWORD i, f=0;
	UBYTE esc[2] = {ESC, ESC};

	for (i=0;i<size;i++){
		if (data[i] == ESC) f += /*fwrite*/RS_Write(esc, sizeof(esc), 1, fileptr);
		else f += /*fwrite*/RS_Write(&(data[i]),1,1,fileptr);
	}
	return (f);
}




DLLEXPORT UWORD STDCALL RS_DevRqst(FILE *fileptr,UBYTE Address, UBYTE *data, UWORD datasize)
{
	UWORD f;
	UBYTE cmd[2] = {0x1,0};

	cmd[1] = Address;


	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_Data(data,datasize,fileptr);	/* Data */
	f += RS_EOP(fileptr);		/* EOP*/

	Cur_IdxW++;		/* increment program index */

	return (f);
}
DLLEXPORT UWORD STDCALL RS_DevRqstMan(FILE *fileptr,UBYTE Address, UBYTE Speed,
										UBYTE Packetsize,UBYTE *data, UWORD datasize)
{
	UWORD f;
	UBYTE cmd[2] = {0x1,0};
	UBYTE temp;
	cmd[1] = Address | 0x80;


	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	temp = (Speed << 2) | Packetsize;
	f += RS_Data(&temp,1,fileptr);
	f += RS_Data(data,datasize,fileptr);	/* Data */
	f += RS_EOP(fileptr);		/* EOP*/

	Cur_IdxW++;		/* increment program index */

	return (f);
}

DLLEXPORT UWORD STDCALL RS_Power(FILE *fileptr,UBYTE State)
{
	UWORD f;
	UBYTE cmd[2] = {2,0};

	cmd[1] = State;	/* copy power on/off state */
	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_EOP(fileptr);	/* EOP */

	Cur_IdxW++;		/* increment program index */

	return(f);
}

DLLEXPORT UWORD STDCALL RS_Suspend(FILE *fileptr)
{
	UWORD f;
	UBYTE cmd = 0x3;

	f = RS_SOP(fileptr);
	f += RS_Data(&cmd,1,fileptr);
	f += RS_EOP(fileptr);

	Cur_IdxW++;		/* increment program index */

	return (f);
}

DLLEXPORT UWORD STDCALL RS_Resume(FILE *fileptr)
{
	UWORD f;
	UBYTE cmd = 0x4;

	f = RS_SOP(fileptr);
	f += RS_Data(&cmd,1,fileptr);
	f += RS_EOP(fileptr);
	
	Cur_IdxW++;		/* increment program index */

	return (f);
}

DLLEXPORT UWORD STDCALL RS_VCC(FILE *fileptr,UBYTE Volts)
{
	UWORD f;
	UBYTE cmd[2] = {5,0};

	cmd[1] = Volts;		/* copy parameter */
	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_EOP(fileptr);	/* EOP */

	Cur_IdxW++;		/* increment program index */

	return(f);
}

DLLEXPORT UWORD STDCALL RS_VccMeasI(FILE *fileptr)
{
	UWORD f;
	UBYTE cmd = 0x6;

	f = RS_SOP(fileptr);
	f += RS_Data(&cmd,1,fileptr);
	f += RS_EOP(fileptr);

	Cur_IdxW++;		/* increment program index */

	return (f);
}

DLLEXPORT UWORD STDCALL RS_RootConfig(FILE *fileptr,UBYTE ParamIdx, UBYTE Data)
{
	UWORD f;
	UBYTE cmd[3] = {7,0,0};

	cmd[1] = ParamIdx;	/* copy parameters */
	cmd[2] = Data;
	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_EOP(fileptr);	/* EOP */

	Cur_IdxW++;		/* increment program index */

	return(f);
}

DLLEXPORT UWORD STDCALL RS_USB_Reset(FILE *fileptr)
{
	UWORD f;
	UBYTE cmd = 0x8;

	f = RS_SOP(fileptr);
	f += RS_Data(&cmd,1,fileptr);
	f += RS_EOP(fileptr);

	Cur_IdxW++;		/* increment program index */

	return (f);
}

DLLEXPORT UWORD STDCALL RS_DevTransIn(FILE *fileptr,UBYTE Address, UBYTE Endpoint, UBYTE pid, UBYTE Control)
{
	UWORD f;
	UBYTE cmd[5] = {0x9,0,0,0,0};

	cmd[1] = Address;
	cmd[2] = Endpoint;
	cmd[3] = pid;
	cmd[4] = Control & 0xfe;	/* direction = in */

	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_EOP(fileptr);		/* EOP*/

	Cur_IdxW++;		/* increment program index */

	return (f);
}


DLLEXPORT UWORD STDCALL RS_DevTransOut(FILE *fileptr,UBYTE Address, UBYTE Endpoint, UBYTE pid, UBYTE Control, UBYTE DataPID, UBYTE* data, UWORD datasize)
{
	UWORD f;
	UBYTE cmd[6] = {0x9,0,0,0,0,0};

	cmd[1] = Address;
	cmd[2] = Endpoint;
	cmd[3] = pid;
	cmd[4] = Control | 1;	/* direction = out */
	cmd[5] = DataPID;

	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_Data(data,datasize,fileptr);	/* Data */
	f += RS_EOP(fileptr);		/* EOP*/

	Cur_IdxW++;		/* increment program index */

	return (f);
}

DLLEXPORT UWORD STDCALL RS_DataPort(FILE *fileptr,UBYTE Data)
{
	UWORD f;
	UBYTE cmd[2] = {0xA,0};

	cmd[1] = Data;	/* copy parameter */

	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_EOP(fileptr);	/* EOP */

	Cur_IdxW++;		/* increment program index */

	return(f);
}

DLLEXPORT UWORD STDCALL RS_RootStatus(FILE *fileptr)
{
	UWORD f;
	UBYTE cmd = 0xB;

	f = RS_SOP(fileptr);
	f += RS_Data(&cmd,1,fileptr);
	f += RS_EOP(fileptr);

	Cur_IdxW++;		/* increment program index */

	return (f);
}

DLLEXPORT UWORD STDCALL RS_Program(FILE *fileptr)
{
	UWORD f;
	UBYTE cmd = 0xC;

	f = RS_SOP(fileptr);
	f += RS_Data(&cmd,1,fileptr);
	f += RS_EOP(fileptr);
	Cur_IdxW = 0;		/* init program index */


	return (f);
}

DLLEXPORT UWORD STDCALL RS_Run(FILE *fileptr)
{

	UWORD f;
	UBYTE cmd = 0xd;

	f = RS_SOP(fileptr);
	f += RS_Data(&cmd,1,fileptr);
	f += RS_EOP(fileptr);

	Cur_IdxW++;		/* increment program index */

	return (f);
}


DLLEXPORT UWORD STDCALL RS_End(FILE *fileptr)
{
	UWORD f;
	UBYTE cmd = 0x21;

	f = RS_SOP(fileptr);
	f += RS_Data(&cmd,1,fileptr);
	f += RS_EOP(fileptr);

	Cur_IdxW++;		/* increment program index */

	return (f);
}


DLLEXPORT UWORD STDCALL RS_Response(FILE *fileptr,UBYTE Mode)
{
	UBYTE cmd[2] = {0x22,0};
	UWORD f;

	cmd[1] = Mode;

	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_EOP(fileptr);		/* EOP*/

	Cur_IdxW++;		/* increment program index */

	return(f);
}


DLLEXPORT UWORD STDCALL RS_Goto(FILE *fileptr,UWORD Index)
{
	UWORD f;

	UBYTE cmd[3] = {0x23,0,0};

	cmd[2] = (UBYTE)(Index % 256);	/* break index into bytes  - Big Endian */
	cmd[1] = (UBYTE)(Index / 256);


	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_EOP(fileptr);		/* EOP*/

	Cur_IdxW++;		/* increment program index */

	return (f);
}

DLLEXPORT UWORD STDCALL RS_If(FILE *fileptr,UBYTE Cond, UWORD Index)
{
	UWORD f;

	UBYTE cmd[4] = {0x24,0,0,0};

	cmd[3] = (UBYTE)(Index % 256);	/* break index into bytes  - Big Endian */
	cmd[2] = (UBYTE)(Index / 256);
	cmd[1] = Cond;					/* add condition code */


	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_EOP(fileptr);		/* EOP*/

	Cur_IdxW++;		/* increment program index */

	return(f);
}


DLLEXPORT UWORD STDCALL RS_Cond(FILE *fileptr,UBYTE Cond, UWORD Index, UBYTE State)
{
	UWORD f;

	UBYTE cmd[5] = {0x25,0,0,0};

	cmd[4] = State;					/* Condition state value */
	cmd[3] = (UBYTE)(Index % 256);	/* break index into bytes  - Big Endian */
	cmd[2] = (UBYTE)(Index / 256);
	cmd[1] = Cond;					/* condition code */


	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_EOP(fileptr);		/* EOP*/

	Cur_IdxW++;		/* increment program index */

	return(f);
}


DLLEXPORT UWORD STDCALL RS_Check(FILE *fileptr, UBYTE Inits)
{
	UWORD f;

	UBYTE cmd[2] = {0x26,0};

	cmd[1] = Inits;					/* add inits byte to command */


	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_EOP(fileptr);		/* EOP*/

	Cur_IdxW++;		/* increment program index */

	return(f);
}


DLLEXPORT UWORD STDCALL RS_Timer(FILE *fileptr,ULONG Count)
{
	UWORD f;

	UBYTE cmd[5] = {0x27,0,0,0,0};

	cmd[4] = (UBYTE)(Count % 256);	/* break 32-bit count into bytes  - Big Endian */
	cmd[3] = (UBYTE)((Count >> 8) % 256);
	cmd[2] = (UBYTE)((Count >> 16) % 256);
	cmd[1] = (UBYTE)((Count >> 24) % 256);


	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_EOP(fileptr);		/* EOP*/

	Cur_IdxW++;		/* increment program index */

	return(f);
}


DLLEXPORT UWORD STDCALL RS_Message(FILE *fileptr,UBYTE *message, UBYTE MsgLen)
{
	UWORD f;

	UBYTE cmd = 0x28;

	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(&cmd,1,fileptr);	/* Command */
	f += RS_Data(message, (UWORD)MsgLen, fileptr);	/* message body */
	f += RS_EOP(fileptr);		/* EOP*/

	Cur_IdxW++;		/* increment program index */

	return (f);
}


DLLEXPORT UWORD STDCALL RS_Call(FILE *fileptr,UWORD Index)
{
	UWORD f;

	UBYTE cmd[3] = {0x29,0,0};

	cmd[2] = (UBYTE)(Index % 256);	/* break index into bytes  - Big Endian */
	cmd[1] = (UBYTE)(Index / 256);


	f = RS_SOP(fileptr);	/* SOP */
	f += RS_Data(cmd,sizeof(cmd),fileptr);	/* Command */
	f += RS_EOP(fileptr);		/* EOP*/

	Cur_IdxW++;		/* increment program index */

	return (f);
}

DLLEXPORT UWORD STDCALL RS_Return(FILE *fileptr)
{
	UWORD f;
	UBYTE cmd = 0x2A;

	f = RS_SOP(fileptr);
	f += RS_Data(&cmd,1,fileptr);
	f += RS_EOP(fileptr);

	Cur_IdxW++;		/* increment program index */

	return (f);
}

DLLEXPORT UWORD STDCALL RS_CurIdx()
{
		return (Cur_IdxW);	/* return current program index */
}
