#ifdef WINDLL
#	define STDCALL _stdcall
#	ifdef CDECL
#	undef  CDECL
#	endif
#	define CDECL _cdecl
#	define DLLEXPORT __declspec( dllexport ) 
#else
#	define STDCALL _stdcall
#	define CDECL
#	define DLLEXPORT
#endif

/* Root-1 Command Prototypes */


typedef struct
{
	UBYTE Address;
	UBYTE Endpoint;
	UBYTE Pid;
	UBYTE DataPid;
	UWORD Control;
	UWORD ServiceInterval;
	UBYTE PacketsPerFrame;
	UWORD Packetsize;
	UBYTE *DataOut;
	ULONG Datalen;
}BLOCK_DEV_TRANS_STRUCT;


DLLEXPORT extern int STDCALL RS_Fclose ( FILE * file );
DLLEXPORT extern FILE * STDCALL RS_Fopen ( char * filepath );
DLLEXPORT extern UWORD STDCALL RS_DevRqst(FILE *fileptr,UBYTE Address, UBYTE *data, UWORD datasize);
DLLEXPORT extern UWORD STDCALL RS_DevRqstMan(FILE *fileptr,UBYTE Address, UBYTE Speed,UBYTE Packetsize,UBYTE *data, UWORD datasize);
DLLEXPORT extern UWORD STDCALL RS_Power(FILE *fileptr,UBYTE State);
DLLEXPORT extern UWORD STDCALL RS_Suspend(FILE *fileptr);
DLLEXPORT extern UWORD STDCALL RS_Resume(FILE *fileptr);
DLLEXPORT extern UWORD STDCALL RS_VCC(FILE *fileptr,UBYTE Volts);
DLLEXPORT extern UWORD STDCALL RS_VccMeasI(FILE *fileptr);
DLLEXPORT extern UWORD STDCALL RS_VccMeasI_DP(FILE *fileptr);
DLLEXPORT extern UWORD STDCALL RS_RootConfig(FILE *fileptr,UBYTE ParamIdx, UBYTE Data);
DLLEXPORT extern UWORD STDCALL RS_USB_Reset(FILE *fileptr);
DLLEXPORT extern UWORD STDCALL RS_DevTransIn(FILE *fileptr,UBYTE Address, UBYTE Endpoint, UBYTE pid, UBYTE Control);
DLLEXPORT extern UWORD STDCALL RS_DevTransOut(FILE *fileptr,UBYTE Address, UBYTE Endpoint, UBYTE pid, UBYTE Control, UBYTE DataPID, UBYTE* data, UWORD datasize);
DLLEXPORT extern UWORD STDCALL RS_DataPort(FILE *fileptr,UBYTE Data);
DLLEXPORT extern UWORD STDCALL RS_MaskDataPort(FILE *fileptr,UBYTE AndVal,UBYTE OrVal);
DLLEXPORT extern UWORD STDCALL RS_RootStatus(FILE *fileptr);
DLLEXPORT extern UWORD STDCALL RS_Program(FILE *fileptr);
DLLEXPORT extern UWORD STDCALL RS_Run(FILE *fileptr);
DLLEXPORT extern UWORD STDCALL RS_Run(FILE *fileptr);
DLLEXPORT extern UWORD STDCALL RS_BlockDevTrans(FILE *fileptr,BLOCK_DEV_TRANS_STRUCT *p);
DLLEXPORT extern UWORD STDCALL RS_BlockDevTransStatus(FILE *fileptr);
DLLEXPORT extern UWORD STDCALL RS_StopBlockDevTrans(FILE *fileptr);

/* RootScript Command Prototypes */
DLLEXPORT extern UWORD STDCALL RS_End(FILE *fileptr);
DLLEXPORT extern UWORD STDCALL RS_Response(FILE *fileptr,UBYTE Mode);
DLLEXPORT extern UWORD STDCALL RS_Goto(FILE *fileptr,UWORD Index);
DLLEXPORT extern UWORD STDCALL RS_If(FILE *fileptr,UBYTE Cond, UWORD Index);
DLLEXPORT extern UWORD STDCALL RS_Cond(FILE *fileptr,UBYTE Cond, UWORD Index, UBYTE State);
DLLEXPORT extern UWORD STDCALL RS_Check(FILE *fileptr, UBYTE Inits);
DLLEXPORT extern UWORD STDCALL RS_Timer(FILE *fileptr,ULONG Count);
DLLEXPORT extern UWORD STDCALL RS_Message(FILE *fileptr,UBYTE *message, UBYTE MsgLen);
DLLEXPORT extern UWORD STDCALL RS_Call(FILE *fileptr,UWORD Index);
DLLEXPORT extern UWORD STDCALL RS_Return(FILE *fileptr);

/* RootScript Support Function Prototypes */
DLLEXPORT extern UWORD STDCALL RS_CurIdx();
DLLEXPORT extern UWORD STDCALL RS_Get_DLL_Version();

/* Status Condition Defines */
#define STS_Success		0
#define STS_ACK			2
#define STS_NAK			0xA
#define STS_STALL		0xE
#define STS_IGNORE		0x80
#define STS_DCRCErr		0x81
#define	STS_DTogErr		0x82
#define	STS_SyncErr		0x83
#define STS_Babble		0x84
#define	STS_PIDErr		0x85
#define	STS_ShPktErr	0x86
#define	STS_ConfigErr	0x87
#define STS_ScheduleErr	    0x88
#define STS_TimeoutErr		0x89
#define STS_NakTimeoutErr	0x8a
#define STS_CmdTimeoutErr	0x8b

/* RS_COND Condition Defines
	These are the possible values for the "Cond" parameter of the
	RS_COND command.
*/
#define CHK_Connect		0x0
#define CHK_Disconnect	0x1
#define CHK_SOF			0x2
#define CHK_Resume		0x3
#define CHK_TrigIn0		0x4
#define CHK_TrigIn1		0x5
#define CHK_Timeout		0x6
#define CHK_Block_Status 0x7


/* RS_CHECK Init Condition Defines 
	These bit-mapped values can be logically OR'd to produce the "Inits"
	parameter to the RS_CHECK command
*/
#define INIT_SOF		0x4
#define INIT_TrigIn0	0x10
#define INIT_TrigIn1	0x20



#define FULL_RESPONSE (UBYTE)0
#define QUIET (UBYTE)1





// Errors values:

#define RS_ERROR_NOWHERE_TO_WRITE -5
#define RS_ERROR_TWO_STREAMS -6

/* RootScript Defines */
#define ESC 0x1b
#define SOP 0x53
#define EOP 0x45


//useful declarations for valid values for Root-1 Commands

//predeclarations for R1_RootConfig command
#define ROOT1_MODE 				0						
#define AUTO_MODE 				1			
#define MANUAL_MODE 			0

#define ROOT1_TRIGGER			1
#define TRIGGERS_DISABLED 		0
#define TRIGGER1_ENABLED  		1
#define TRIGGER2_ENABLED  		2	


#define ROOT1_AUTORECOVERY		2	
#define AUTORECOVERY_ENABLED	1	
#define AUTORECOVERY_DISABLED	2

#define ROOT1_LED_INDICATORS    3
#define ENABLE_LED_INDICATORS   1
#define DISABLE_LED_INDICATORS  0

#define ROOT1_PUSHBUTTONS		4
#define ENABLE_PUSHBUTTONS		1
#define DISABLE_PUSHBUTTONS		0

#define ROOT1_BAUD				5
//Baud set according to following table:
#define ROOT1_BAUD_2400			0  //-- 2400
#define ROOT1_BAUD_9600			1 // -- 9600
#define ROOT1_BAUD_19200			2 // -- 19200
#define ROOT1_BAUD_38400			3 // -- 38400
#define ROOT1_BAUD_57600			4 // -- 57600
#define ROOT1_BAUD_115200			5 // -- 115200
#define ROOT1_BAUD_230400			6 // -- 230400
#define ROOT1_BAUD_460800			7 // -- 460800


#define ROOT1_CONNECT_SPEED_CONTROL     6
#define INHIBIT_HS						1
#define ALLOW_HS						0

//predeclarations for R1_Power
#define POWER_OFF 				0						
#define POWER_ON 				1			

//useful PID declarations for R1_DevRqst, R1_DevTransXXX
#define OUT_PID				0x1
#define ACK_PID				0x2
#define DATA0_PID			0x3
#define PING_PID			0x4
#define NYET_PID			0x6
#define DATA2_PID			0x7
#define IN_PID 				0x9
#define NAK_PID				0xa
#define DATA1_PID 			0xB
#define SETUP_PID 			0xD
#define STALL_PID			0xe
#define MDATA_PID			0xf





//DevRqst predefines
#define DR_PACKETSIZE_8		0
#define DR_PACKETSIZE_16	1
#define DR_PACKETSIZE_32	2
#define DR_PACKETSIZE_64	3
#define DR_HIGH_SPEED		2
#define DR_FULL_SPEED		1
#define DR_LOW_SPEED		0

//DevTrans -- use with device transaction commands only!

#define DT_LOW_SPEED			0x0000		//perform transaction at low speed
#define DT_FULL_SPEED			0x0002		//perform transaction at full speed
#define DT_HIGH_SPEED			0x0008		//perform transaction at high speed
#define DT_ISOCH 				0x0004		//perform isochronous transaction 
#define DT_USE_ALT_BUFFER		0x0010		//use alternate buffer
#define DT_NEXT_DATAPID			0x0040		//use next datapid in sequence (data0/data1)
#define DT_IMMED				0x0080		//issue transaction without waiting for sof

//these can  only be used with block dev trans command
#define DT_LOOP					0x0100		//loop this transaction indefinitely
#define DT_STOP_ON_NAK			0x0200		//stop transaction when device NAKs



//used in conjunction with response from R1_RootStatus command		
#define ROOTSTATUS_CONNECT_MASK				0x43
#define ROOTSTATUS_POWER_MASK   			4
#define ROOTSTATUS_SUSPEND_MASK 			8
#define ROOTSTATUS_ENABLED_MASK 			0x10
#define ROOTSTATUS_AUTORECOVERY_MASK		0x20

#define ROOTSTATUS_NOT_CONNECTED  			0	
#define ROOTSTATUS_FULL_SPEED_CONNECT		2	
#define ROOTSTATUS_LOW_SPEED_CONNECT		1		
#define ROOTSTATUS_HIGH_SPEED_CONNECT		0x40
#define ROOTSTATUS_CONNECTED				0x43		

